<template>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable"   @edit-end="handleEditEnd" @edit-cancel="handleEditCancel" :beforeEditSubmit="beforeEditSubmit" :loading="isLoading">
     <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
        <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-button type="primary" @click="handleCustomImport" preIcon="ant-design:plus-outlined">从EXCEL导入</a-button>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
     
        </template>
     
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'tolVal'">
            【{{record.stTolVal}}~{{record.tolVal}}】
          </template>
          <template v-if="column.key === 'warnVal'">
            ({{record.tolVal}}~{{record.warnVal}}）
          </template>
          <template v-if="column.key === 'intvVal'">
            【{{record.warnVal}}~{{record.intvVal}}】
          </template>
      </template>
    </BasicTable>
    <!-- 表单区域 --> 

    <MetricMonitorSetModal @register="registerModal" @success="handleSuccess"></MetricMonitorSetModal>
    <MetricFomulasModal @register="registerFomulasModal" @success="handleSuccess"></MetricFomulasModal>
    <MetricApiCfgModal @register="registerAPICofngModal" @success="handleSuccess"></MetricApiCfgModal>
    <MetricMonitorSetHistory @register="registerMetricSetHistory" @success="handleSuccess"></MetricMonitorSetHistory>
    
  </div>
  <Import ref="refImport" @callback="importCallback"></Import>
</template>

<script lang="ts" name="metric-metricMonitorSet" setup>
  import {ref, computed, unref} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import MetricMonitorSetModal from './components/MetricMonitorSetModal.vue'
  import MetricFomulasModal from './components/MetricFomulasModal.vue'
  import Import from '/@/views/audit/common/components/import.vue'
  import MetricMonitorSetHistory from './components/MetricMonitorSetHistory.vue'
  import {columns, searchFormSchema,formSchema} from './MetricMonitorSet.data';
  import {list, deleteOne, batchDelete, getImportUrl,getExportUrl,saveOrUpdate,batchImmportBase} from './MetricMonitorSet.api';
  import MetricApiCfgModal from './components/MetricApiCfgModal.vue'
  import {queryAll} from './MetricApiCfg.api';

  import { usePermission } from '/@/hooks/web/usePermission';
  
  const { hasPermission } = usePermission();

  const refImport = ref();
  const isLoading = ref(false)
  
  //注册model
  const [registerModal, {openModal}] = useModal();
  const [registerBatchModal, {openModal:openBatchModal}] = useModal();
  const [registerFomulasModal, {openModal:openFomulasModal}] = useModal();
  const [registerAPICofngModal, {openModal:openAPIConfigModal}] = useModal();
  const [registerMetricSetHistory, {openModal:openHistory}] = useModal();
  
  
  //注册table数据
  const { tableContext,onExportXls,onImportXls} = useListPage({
      tableProps:{
          title: '监测方案',
          api: list,
          columns,
          canResize:true,
          defSort :{
             column: 'id',
             order: 'asc',
          },
          formConfig: {
            schemas: searchFormSchema,
            autoSubmitOnEnter:true,
            showAdvancedButton:true,
            fieldMapToNumber: [
            ],
            fieldMapToTime: [
            ],
          },
          actionColumn: {
            width: 150,
            fixed:'right'
          },
      },  
      exportConfig: {
        name:"指标导出",
        url: getExportUrl,
      },
      importConfig: {
        url: getImportUrl,
        success: handleSuccess
      },
  })

  const [registerTable, {reload},{ rowSelection, selectedRowKeys }] = tableContext


   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       mtrcCtp:1,
       isUpdate: false,
       showFooter: true,
     });
  }

   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }


   function handleHistory(record: Recordable) {
     openHistory(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }


   function handleFormulas(record: Recordable) {
    openFomulasModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }

  async function handleAPIConfig(record: Recordable) {
    let dataList = await queryAll({mtrcNo:record.mtrcNo})
    let data = {}
    if(dataList&&dataList.length>0) {
      data = dataList[0]
      openAPIConfigModal(true, {
        record:data,
        isUpdate: true,
        showFooter: true,
      });
    } else {
      openAPIConfigModal(true, {
        record,
        isUpdate: false,
        showFooter: true,
      });
    }
     return false
   }


   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
    let obj =  [{
          label: '编辑',
          disabled:false,
          onClick: handleEdit.bind(null, record),
    }]
    obj.push({
      label: '接口配置',
      disabled:record.collMethod==1?true:false,
      onClick: handleAPIConfig.bind(null, record),
    })
    return obj
  }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
          label: '修改历史',
          onClick: handleHistory.bind(null, record),

         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         }
       ]
   }


    async function beforeEditSubmit({ record, index, key, value }) {
      let tmpPbj = {
        id:record.id,
        mtrcNo:record.mtrcNo,
      }
      tmpPbj[key] = value
      await saveOrUpdate(tmpPbj);
    }

    function handleEditCancel() {
      console.log('cancel');
    }

    function handleEditEnd({ record, index, key, value }: Recordable) {
      handleSuccess()
      return false;
    }

    const importCallback = async (datas) => {
      isLoading.value = true
      const result = await  datas.map(item => ({
        ...item,
        stTolVal: extractFirstNumber(item.stTolVal),
        tolVal: extractFirstNumber(item.tolVal),
        warnVal: extractFirstNumber(item.warnVal),
        intvVal: extractFirstNumber(item.intvVal)
      }));

      await batchImmportBase(result);
      await reload();

      isLoading.value = false
    }


    const handleCustomImport = () => {
      refImport.value.iniData(formSchema)
    }


    function extractFirstNumber(value) {
      if (!value || typeof value !== 'string') return null;
      const match = value.match(/^(\d+)/);
      return match ? parseInt(match[1]) : null;
    }

  
</script>

<style scoped>

</style>